#pragma once

#include <cstdint>

enum class NPCSpritesheetFrames : std::uint16_t
{
    BAT_HANG = 0,
    BAT_FLYING_0_FIRST,
    BAT_FLYING_1,
    BAT_FLYING_2_LAST,
    SNAKE,
    SNAKE_WALK_0_FIRST,
    SNAKE_WALK_1,
    SNAKE_WALK_2,
    SNAKE_WALK_3_LAST,
    CAVEMAN,
    CAVEMAN_RUN_0_FIRST,
    CAVEMAN_RUN_1,
    CAVEMAN_RUN_2,
    CAVEMAN_RUN_3_LAST,
    CAVEMAN_STUNNED_0_FIRST,
    CAVEMAN_STUNNED_1,
    CAVEMAN_STUNNED_2,
    CAVEMAN_STUNNED_3,
    CAVEMAN_STUNNED_4_LAST,
    CAVEMAN_STUNNED_HELD_0_FIRST,
    CAVEMAN_STUNNED_HELD_1,
    CAVEMAN_STUNNED_HELD_2,
    CAVEMAN_STUNNED_HELD_3,
    CAVEMAN_STUNNED_HELD_4_LAST,
    CAVEMAN_HELD,
    CAVEMAN_BOUNCE,
    CAVEMAN_FALL,
    CAVEMAN_DEAD,
    SPIKES,
    SPIKES_BLOOD,
    ARROW,
    ARROW_ANGLED_0_FIRST, // Each frame adds 20 degrees rotation, making up 180:
    ARROW_ANGLED_1,
    ARROW_ANGLED_2,
    ARROW_ANGLED_3,
    ARROW_ANGLED_4,
    ARROW_ANGLED_5,
    ARROW_ANGLED_6,
    ARROW_ANGLED_7,
    ARROW_ANGLED_8_LAST,
    SPIDER_HANG,
    SPIDER_FLIP_0_FIRST,
    SPIDER_FLIP_1,
    SPIDER_FLIP_2,
    SPIDER_FLIP_3,
    SPIDER_FLIP_4,
    SPIDER_FLIP_5,
    SPIDER_FLIP_6,
    SPIDER_FLIP_7,
    SPIDER_FLIP_8_LAST,
    SPIDER_TRIGGERED_0_FIRST,
    SPIDER_TRIGGERED_1,
    SPIDER_TRIGGERED_2,
    SPIDER_TRIGGERED_3_LAST,
    SKELETON_CREATE_0_FIRST,
    SKELETON_CREATE_1,
    SKELETON_CREATE_2,
    SKELETON_CREATE_3,
    SKELETON_CREATE_4,
    SKELETON_CREATE_5_LAST,
    SKELETON_WALK_0_FIRST,
    SKELETON_WALK_1,
    SKELETON_WALK_2,
    SKELETON_WALK_3,
    SKELETON_WALK_4_LAST,
    SKULL,
    BONES,
    BONES_PARTICLE_0_START,
    BONES_PARTICLE_1,
    BONES_PARTICLE_2,
    BONES_PARTICLE_3,
    BONES_PARTICLE_4,
    BONES_PARTICLE_5,
    BONES_PARTICLE_6,
    BONES_PARTICLE_7_LAST,
    SHOPKEEPER_STANDING,
    SHOPKEEPER_RUN_0_START,
    SHOPKEEPER_RUN_1,
    SHOPKEEPER_RUN_2,
    SHOPKEEPER_RUN_3,
    SHOPKEEPER_RUN_4,
    SHOPKEEPER_RUN_5_LAST,
    SHOPKEEPER_FALLING,
    SHOPKEEPER_BOUNCING,
    SHOPKEEPER_DEAD_HELD,
    SHOPKEEPER_DEAD,
    SHOPKEEPER_STUNNED_0_START,
    SHOPKEEPER_STUNNED_1,
    SHOPKEEPER_STUNNED_2,
    SHOPKEEPER_STUNNED_3,
    SHOPKEEPER_STUNNED_4,
    SHOPKEEPER_STUNNED_5_LAST,
    SHOPKEEPER_HELD_STUNNED_0_START,
    SHOPKEEPER_HELD_STUNNED_1,
    SHOPKEEPER_HELD_STUNNED_2,
    SHOPKEEPER_HELD_STUNNED_3,
    SHOPKEEPER_HELD_STUNNED_4,
    SHOPKEEPER_HELD_STUNNED_5_LAST,
    DAMSEL_HELD,
    DAMSEL_BOUNCE,
    DAMSEL_DEAD,
    DAMSEL_KISS_0_START,
    DAMSEL_KISS_1,
    DAMSEL_KISS_2,
    DAMSEL_KISS_3,
    DAMSEL_KISS_4,
    DAMSEL_KISS_5,
    DAMSEL_KISS_6,
    DAMSEL_KISS_7,
    DAMSEL_KISS_8,
    DAMSEL_KISS_9_LAST,
    DAMSEL_STUNNED_0_START,
    DAMSEL_STUNNED_1,
    DAMSEL_STUNNED_2,
    DAMSEL_STUNNED_3,
    DAMSEL_STUNNED_4_LAST,
    DAMSEL_YELL_0_START,
    DAMSEL_YELL_1,
    DAMSEL_YELL_2,
    DAMSEL_YELL_3,
    DAMSEL_YELL_4,
    DAMSEL_YELL_5,
    DAMSEL_YELL_6,
    DAMSEL_YELL_7,
    DAMSEL_YELL_8,
    DAMSEL_YELL_9_LAST,
    DAMSEL_RUN_0_START,
    DAMSEL_RUN_1,
    DAMSEL_RUN_2,
    DAMSEL_RUN_3_LAST,
    DAMSEL_FALL,
    DAMSEL_EXITING_0_START,
    DAMSEL_EXITING_1,
    DAMSEL_EXITING_2,
    DAMSEL_EXITING_3,
    DAMSEL_EXITING_4,
    DAMSEL_EXITING_5,
    DAMSEL_EXITING_6,
    DAMSEL_EXITING_7,
    DAMSEL_EXITING_8,
    DAMSEL_EXITING_9,
    DAMSEL_EXITING_10,
    DAMSEL_EXITING_11,
    DAMSEL_EXITING_12,
    DAMSEL_EXITING_13,
    DAMSEL_EXITING_14,
    DAMSEL_EXITING_15_LAST,
    DAMSEL_STANDING,
    SMOOCH_HEART_0_START,
    SMOOCH_HEART_1_LAST,
    YELL_HELP
};
