### Notes for 3rd party projects shipped with Spelunky-PSP.

#### GLM

Though I am compiling Spelunky-PSP with `-std=C++14`, STL on PSP is not fully implemented
and building vanilla GLM fails.

Because of that, I am forcily undefining `GLM_HAS_CXX11_STL` in `glm/glm/setup.hpp`, to use
math helpers shipped with glm instead of those from STL.

#### Glad

Though contents of these files are auto generated output from:

[https://github.com/Dav1dde/glad](https://github.com/Dav1dde/glad)

I had to manually add loading pointer to *glOrtho* into OpenGL ES 1.0 project.

OpenGL ES 1.0 specification provides *glOrthox* and *glOrthof* in its headers, 
but no glOrtho, and OpenGL 1.3 provides glOrtho, but no glOrthox and glOrthof.
  
Because I wanted to use only common OpenGL functions, with no conditional, per-platform branching,
small change in autogenerated headers seemed to be the lesser evil.
 
